# curve_editor.py
# Widget and associated undo commands for cubic Bezier curve editing

# Robert Bridson
# Released under the GPLv3

from copy import deepcopy
import math
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from cubic_bezier import CubicBezier

class ChangeValueCommand(QUndoCommand):
    def __init__(self, editor, index, newValue, description):
        QUndoCommand.__init__(self, description)
        self.editor = editor
        self.index = index
        self.oldValue = editor.curve.values[index]
        self.newValue = newValue

    def undo(self):
        self.editor.setValue(self.index, self.oldValue)

    def redo(self):
        self.editor.setValue(self.index, self.newValue)

class SplitCurveCommand(QUndoCommand):
    def __init__(self, editor, t, description):
        QUndoCommand.__init__(self, description)
        # YOU FILL CODE IN HERE TO SAVE DESIRED INFORMATION

    def undo(self):
        # YOU FILL CODE IN HERE TO RESTORE TO OLD STATE
        pass

    def redo(self):
        # YOU FILL CODE IN HERE TO ACTUALLY SPLIT THE INTERVAL
        pass

class RemoveKnotCommand(QUndoCommand):
    def __init__(self, editor, index, description):
        QUndoCommand.__init__(self, description)
        # YOU FILL CODE IN HERE TO SAVE DESIRED INFORMATION

    def undo(self):
        # YOU FILL CODE IN HERE TO RESTORE TO OLD STATE
        pass

    def redo(self):
        # YOU FILL CODE IN HERE TO ACTUALLY SPLIT THE INTERVAL
        pass

class CurveEditor(QWidget):
    """
    CurveEditor is a Qt widget for displaying and editing CubicBezier curves
    """

    def __init__(self, curve, undoStack, parent = None):
        """
        Pass in the CubicBezier curve to be edited, application's QUndoStack, and maybe a parent QWidget.
        """
        QWidget.__init__(self, parent)
        # save the undo stack for future reference
        self.undoStack = undoStack
        # the CubicBezier we are currently editing
        self.curve = curve
        # YOU FILL CODE IN HERE TO INITIALIZE ANYTHING ELSE YOU NEED
        # (FOR EXAMPLE, INFO FOR WHEN USER IS DRAGGING A CONTROL POINT OR NOT)

    def setValue(self, index, newValue):
        """
        Change the value of the given index control point in self.curve
        """
        self.curve.values[index] = newValue
        self.tempCurve.values[index] = newValue
        self.update()

    # YOU FILL CODE IN HERE (MORE METHODS) TO SUPPORT ANY OTHER OPERATIONS
    # YOU NEED (E.G. THINGS THE SplitCurveCommand AND RemoveKnotCommand MAY
    # NEED TO OPERATE)

    def mousePressEvent(self, event):
        # YOU FILL CODE IN HERE TO HANDLE THE START OF A LEFT OR RIGHT CLICK
        pass

    def mouseDoubleClickEvent(self, event):
        # YOU FILL CODE IN HERE TO HANDLE A DOUBLE-CLICK (SUBDIVIDE) EVENT
        pass

    def mouseMoveEvent(self, event):
        # YOU FILL CODE IN HERE TO HANDLE DRAGGING A CONTROL POINT TO A NEW
        # VALUE
        pass

    def mouseReleaseEvent(self, event):
        # YOU FILL CODE IN HERE TO HANDLE THE END OF A CONTROL POINT CHANGE:
        # CONSTRUCT A NEW ChangeValueCommand, CALL self.undoStack.push(cmd),
        # CALL self.update(), AND RESET ANY STATE YOU NEED TO.
        pass

    def paintEvent(self, event):
        painter = QPainter(self)
        painter.setRenderHint(QPainter.Antialiasing)

        # clear the bit we need to repaint with white, set only to draw there
        dirtyRect = event.rect()
        painter.fillRect(dirtyRect, Qt.white)
        painter.setClipRect(dirtyRect)

        # YOU FILL CODE IN HERE TO DRAW THE DISPLAY ON THE WIDGET ITSELF
        # (USING painter)

        # finish up
        painter.end()

