from PyQt4.QtCore import *
from PyQt4.QtGui import *

from curve_editor import *
from cubic_bezier import *
from framecontrol import *

class MainWindow(QMainWindow):
    """
    MainWindow is the controller/owner of the curve editor application.
    """

    def __init__(self):
        QMainWindow.__init__(self)

        # YOU WILL NEED MORE THAN A SINGLE CURVE EVENTUALLY...
        self.curve = CubicBezier(99)

        self.undoStack = QUndoStack()
        self.undoAct = self.undoStack.createUndoAction(self, self.tr("&Undo"))
        self.undoAct.setShortcuts(QKeySequence.Undo)
        self.redoAct = self.undoStack.createRedoAction(self, self.tr("&Redo"))
        self.redoAct.setShortcuts(QKeySequence.Redo)
        self.editMenu = QMenu("&Edit", self)
        self.editMenu.addAction(self.undoAct)
        self.editMenu.addAction(self.redoAct)
        self.menuBar().addMenu(self.editMenu)
    
        self.editor = CurveEditor(self.curve, self.undoStack)

        self.fc = FrameControl()

        # establish GUI
        self.setWindowTitle("Motion Curves")
        self.gui = QWidget(self) # a dummy widget to hold the layout
        self.vbox = QVBoxLayout(self.gui)
        self.vbox.addWidget(self.editor, 1)
        self.vbox.addWidget(self.fc, 0)
        self.setCentralWidget(self.gui)

